/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.*;
	import flash.filters.GlowFilter;
	import flash.geom.ColorTransform;
	import com.llops.utils.FPS;
	import com.llops.utils.Random;
	import flash.utils.Timer;
	import Pixel;
	
	public class Main extends Sprite
	{		
		// MC en el escenario
		public var marco_mc:MovieClip;
		public var mensaje_mc:MovieClip;
		
		// Medidas escenario
		public static var ANCHO:int = 300;
		public static var ALTO:int = 150;
		
		// Bitmap
		private var _bmpData:BitmapData = new BitmapData(ANCHO, ALTO, true, 0);
		private var _bmp:Bitmap = new Bitmap(_bmpData);
		
		// Colores
		public const ROJO:uint = 0xFFFF0000;
		public const NARANJA:uint = 0xFFFF9900;
		
		private var _color_pixel:uint = NARANJA;
		private var _color_glow:uint = ROJO;
		
		// Variables
		private var _cont:int = 0;
		private var _init:Boolean = false;
		private var _pixels:Array = new Array();
		
		// Variables para controlar los pixels
		private var _max_pixels:int = 700;
		private var _pixels_por_frame:int = 10;
		
		// Posiciones pixel
		private var posx:int = ANCHO-5;
		private var posy:int = 50;
		
		// Color transform para el fade
		private var _ct:ColorTransform = new ColorTransform();
		
		// Variable para la pausa
		private var _timer_pausa:Timer;
		
		
		function Main() 
		{
			// Aadir el bitmap
			addChild(_bmp);
			
			// Poner el marco por encima de todo
			addChild(marco_mc);
			
			// Aadir Medidor de frames por segundo
			var fps:FPS = new FPS();
			fps.x = ANCHO/2 - fps.width/2;
			fps.y = 10;
			addChild(fps);
			
			// Fijar el nivel de alfa para el Fade
			_ct.alphaMultiplier = .92;
			
			// Crear y aplicar el filtro Glow
			var _glow:GlowFilter = new GlowFilter(_color_glow, 1, 12, 12);
			_bmp.filters = [_glow];
			
			
			// Eventos
			stage.addEventListener(Event.ENTER_FRAME, render);
			stage.addEventListener(MouseEvent.CLICK, iniciar);
			stage.addEventListener(Event.MOUSE_LEAVE, pausar);
		}
		
		private function iniciar(e:MouseEvent):void
		{
			if (!_init) {
				mensaje_mc.visible = false;
				_init = true;
			}
		}
		
		private function render(e:Event):void 
		{
			if (_init)
			{
				if (_pixels.length <= _max_pixels)
				{
					for (var i:int = 0; i < _pixels_por_frame; i++) 
					{
						_pixels.unshift(new Pixel(_cont, posx, posy));
						_cont++;
					}
				}
				
				for (var a:String in _pixels) 
				{
					var p:Pixel = _pixels[a];
					
					_bmpData.setPixel32(p.x, p.y, _color_pixel);
					p.mover();
					
					if (p.y > ALTO) eliminarPixel(p);
				}
			}
			
			// Aplicar Fade
			_bmpData.colorTransform(_bmpData.rect, _ct);
			
			//trace("Longitud:", _pixels.length);
		}
		
		private function eliminarPixel(p:Pixel):void
		{
			var long:int = _pixels.length;
			for (var i:int = 0; i < long; i++) 
			{
				if (p == _pixels[i])
				{
					//trace("Eliminar", p.name);
					_pixels.splice(i, 1);
				}
			}
		}
		
		// --
		// Mtodos para la PAUSA
		// --
		private function pausar(e:Event):void 
		{
			//trace("Peticion pausar");
			_timer_pausa = new Timer(1000, 1);
			_timer_pausa.addEventListener(TimerEvent.TIMER_COMPLETE, function():void 
				{
					if (_init) {
						//trace("Pausa Activa");
						_init = false;
						mensaje_mc.visible = true;
					}
				});
			_timer_pausa.start();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, despausar);
		}
		
		private function despausar(e:MouseEvent):void 
		{
			//trace("desPausa");
			_timer_pausa.stop();
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, despausar);
		}
	}
}